	// Последнее обновление 2018-07-25 by Phisik
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Здесь всяческий вывод на экран
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "configuration.h"
#include "declarations.h"

char flNumStrPrint = 0;

#if SHOW_FLOAT_TEMPERATURES
	#define PRINT_TEMPERATURES() { String msg = "T=" + String(0.1*DS_TEMP(TEMP_KUB), 1) + "," + String(0.1*DS_TEMP(TEMP_DEFL), 1) + "," + String(0.1*DS_TEMP(TEMP_TSA), 1);\
								   strcpy(lcd_buffer, msg.c_str());\
							       my_lcdprint(lcd_buffer);\
    }
#else
	#define PRINT_TEMPERATURES() { sprintf_P(lcd_buffer, PSTR("D2 T=%3i,%3i,%3i"), DS_TEMP(TEMP_KUB), DS_TEMP(TEMP_RK20), DS_TEMP(TEMP_TSA));\
								 my_lcdprint(lcd_buffer);\
	}
#endif


void my_lcdprint(char *s)
{
	char i;
	char len;
	len = strlen(lcd_buffer);
	for (i = len; i < LCD_WIDTH; i++)
		s[i] = ' ';
	s[LCD_WIDTH] = 0;

	if (IspReg == 111 && s[9] == 'R' && flNumStrPrint == 0) s[9] = 'N';

	lcd.print(s);

	// MQTT code by max506 & limon
#if USE_MQTT_BROKER

	if (flNumStrPrint == 0) {

		snprintf_P(lcd_mqtt_buf1, MQTT_BUFFER_SIZE, fmt_lcd1, s);

		// Убрать завершающие пробелы
		for (i = strlen(lcd_mqtt_buf1) - 1; ; i--) {
			if (lcd_mqtt_buf1[i] == ' ') lcd_mqtt_buf1[i] = '\0';
			else break;
		}
	}
	else if (flNumStrPrint == 1) {
		snprintf_P(lcd_mqtt_buf2, MQTT_BUFFER_SIZE, fmt_lcd2, s);

		// Убрать завершающие пробелы
		for (i = strlen(lcd_mqtt_buf2) - 1; ; i--) {
			if (lcd_mqtt_buf2[i] == ' ') lcd_mqtt_buf2[i] = '\0';
			else break;
		}
	}
#endif // USE_MQTT_BROKER

#if USE_GSM_WIFI==1

	// Если состояние отправки - надо отправить экран, тогда отправляем еще и на сервер.
	if (flGPRSState == 20 || flGPRSState == 164)
	{
		if (flNumStrPrint == 0)
		{   // Первой строчкой отправляем id устройства и первую строку экрана
			sprintf_P(my_gprs_buffer, PSTR("%s;%s"), idDevice, s);
			GSM_SERIAL.print(my_gprs_buffer);
#ifdef TESTGSM
			DEBUG_SERIAL.println(F("SendDTA1:"));
			DEBUG_SERIAL.println(my_gprs_buffer);
#endif

		}
		else
		{   // Второй строчкой отправляем нужную часть экрана, состояние контроллера и последнюю выполненную команду. 
			sprintf_P(my_gprs_buffer, PSTR("%s;%3i;%3i;%c#"), s, (int)IspReg, (int)StateMachine, cmdGPRSIsp);
			GSM_SERIAL.println(my_gprs_buffer);
#ifdef TESTGSM
			DEBUG_SERIAL.println(F("SendDTA2:"));
			DEBUG_SERIAL.println(my_gprs_buffer);
#endif
			flGPRSState++; // Переводим контроллер в состояние отправлено.
			//timeWaitGPRS=20;
			timeWaitGPRS = 2; // Две секунды достаточно для отправки
		}
	}
#endif

	flNumStrPrint++;

#ifdef TESTMEM
	DEBUG_SERIAL.println(F("\n[memCheck_print]"));
	DEBUG_SERIAL.println(freeRam());
#endif
}

unsigned char hour, minute, second;
int V1, V2, V3;

void formTRZGDistill()
{
	if (TempDeflBegDistil > 0){ sprintf_P(lcd_buffer, PSTR("   Pw = %4iW"), Power);             											//   Pw =
  my_lcdprint(lcd_buffer);
	sprintf_P(lcd_buffer, PSTR("  T* \343e\344-pa = %3i/%3i"), DS_TEMP(TEMP_DEFL), TempDeflBegDistil);   									//  T* деф-ра =
	}
	else {sprintf_P(lcd_buffer, PSTR("   Pw = %4iW"), Power);                                   											//   Pw =
  my_lcdprint(lcd_buffer);
	sprintf_P(lcd_buffer, PSTR("T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), -TempDeflBegDistil);     										// T* куба =
  }                            
}

void formTSAErr()
{
	sprintf_P(lcd_buffer, PSTR(" %02u:%02u:%02u \250pe\263\303\301e\275a"), hour, minute, second);                      					// 00:00:00 Превышена
	//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
	my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
  lcd.setCursor(0,3);
  sprintf_P(lcd_buffer, PSTR("  T* TCA = %3i/%3i"), DS_TEMP(TEMP_TSA), MAX_TEMP_TSA);                										//  T* ТСА =
  my_lcdprint(lcd_buffer); 
  lcd.setCursor(0,2);	
  sprintf_P(lcd_buffer,PSTR("  T* TCA!!!"));                                                        										//  T* ТСА!!!
}

void DisplayRectif()
{
	if (DispPage == 0)
	{
		switch (StateMachine)
		{
		case 0: //Не запущено
		case 1: //Не запущено
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277\270\344-\345\270\307"), hour, minute, second);                        	//00:00:00 Ректиф-ция
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			//sprintf_P(lcd_buffer,PSTR("tK=%3i P=%4i"),DS_TEMP(TEMP_KUB),Power); 
			break;
		case 2: //Разгон
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.pa\267\264o\275"), hour, minute, second);                                  //00:00:00 Рект.разгон
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			if (tEndRectRazgon > 0) {sprintf_P(lcd_buffer, PSTR(" \272o\273o\275\275\303 = %3i/%3i"), DS_TEMP(TEMP_KUB), tEndRectRazgon); 	// колонны =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw = %4iW"), UstPower);                                              			// Заданная Pw =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
	    sprintf_P(lcd_buffer, PSTR(" T* pa\267\264o\275a"));                                    			                    			// T* разгона                                  
}else{
      sprintf_P(lcd_buffer, PSTR(" \272o\273o\275\275\303 = %3i/%3i"), DS_TEMP(TEMP_RK20), -tEndRectRazgon);			                  	// колонны =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw  = %4iW"), UstPower);                                              			// Заданная Pw =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR(" T* pa\267\264o\275a"));                                                              					// T* разгона                            
      }
      break;		
      	
		case 3: //Стабилицация колонны
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.c\277a\262-\307"), hour, minute, second);                            		//00:00:00 Рект.стаб-я
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); 
      sprintf_P(lcd_buffer, PSTR("                    "));
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR(" \250o\343-\307 Pw = %4iW"), PowerRect);                               								// Под-я Pw =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("PK(20)=%3i(%3i)"), DS_TEMP(TEMP_RK20), (IspReg == 111 ? (int)(SecOstatok) : (int)(Seconds - SecTempPrev)));
			break;
		case 4: //Отбор голов
			if (IspReg != 118)
			{
				sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.\264o\273o\263\303"), hour, minute, second);                     		//00:00:00 Рект.головы
				//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     

				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				if (UrovenProvodimostSR == 0)
         {
					sprintf_P(lcd_buffer, PSTR(" \250o\343-\307 Pw = %4iW"), PowerRect);                         							// Под-я Pw =
          my_lcdprint(lcd_buffer); 
          sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), tEndRectOtbGlv);           							// T* куба =
         }
				else 
				 {
					if (UrovenProvodimostSR > 0)
					 {
						if (UrovenProvodimostSR == 2) 
						  {
						   sprintf_P(lcd_buffer, PSTR(" \250o\343-\307 Pw = %4iW"), PowerRect);                     						// Под-я Pw =
               my_lcdprint(lcd_buffer);
               sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \264o\273o\263 = %3i/%3i"), U_GLV, UROVEN_ALARM);         					//Уровень голов =
						  }
					  else 
					    {
				       sprintf_P(lcd_buffer, PSTR(" \250o\343-\307 Pw = %4iW"), PowerRect);                     							//Под-я Pw =
               my_lcdprint(lcd_buffer);
               sprintf_P(lcd_buffer, PSTR("\251p-\275\304 \276po\263o\343-\277\270=%3i/%3i"), U_GLV, UrovenProvodimostSR); 					//Ур-нь провод-ти=
					    }
					 }
				 else 
				   {
            sprintf_P(lcd_buffer, PSTR(" \250o\343-\307 Pw = %4iW"), PowerRect);						              						// Под-я Pw =
            my_lcdprint(lcd_buffer); 
            sprintf_P(lcd_buffer, PSTR("C\277a\262-345\270\307 PK = %3i/%3i"), (int)SecOstatok, -UrovenProvodimostSR);   					//Стаб-ция РК =
					 }
				 } 
			}
			else
			{

				sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.\344p.\264o\273"), hour, minute, second);                       		//00:00:00 Рект.фр.гол
				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
				if (TekFraction < CountFractionRect) V2 = TempFractionRect[TekFraction];
				if (V2 >= 0) {sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), V2);           					// T* куба =
                     my_lcdprint(lcd_buffer);
                     lcd.setCursor(0,2); 
                     sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw  = %4iW"), UstPower);                     						// Заданная Pw =
                     }
        else { sprintf_P(lcd_buffer, PSTR(" C\277a\262-345\270\307 PK: %5i"), (int)SecOstatok);                          					// Стаб-ция РК:
               my_lcdprint(lcd_buffer);
               lcd.setCursor(0,2); 
               sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw  = %4iW"), UstPower);                           						// Заданная Pw =
			       }
			     } 
			break;
		case 5: //Стоп, ожидание возврата температуры
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277. STOP"), hour, minute, second);                             				//00:00:00 Рект. STOP
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("o\277\262opa c\276\270p\277a = %2i%%"), ProcChimSR);                                   					//отбора спирта =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("Te\272\171\346\270\271 ypo\263e\275\304"));                                     							//Текущий уровень
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR("PK(20) = %3i/%3i"), DS_TEMP(TEMP_RK20), tStabSR);                                   				//РК(20) = 
			break;
		case 6: //Ректификация
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.c\277a\262 %2i%%"), hour, minute, second, ProcChimSR);            		//00:00:00 Рeкт.стаб
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("PK(20)=%3i/%3i/d%2i"), DS_TEMP(TEMP_RK20), tStabSR + tDeltaRect, tDeltaRect);
			break;
		case 7: //Отбор хвостов
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277.x\263oc\277"), hour, minute, second);										//00:00:00 Рeкт.хвост
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), IspReg != 118 ? tEndRect : TekTemp); 				// T* куба =   
			break;
		case 8: //Отбор ожидание 3 минут
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277. \243\340\242M"), hour, minute, second);                               	//00:00:00 Рект. ЖДЁМ
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), IspReg != 118 ? tEndRect : TekTemp); 				// T* куба = 
			break;
		case 9: //Ожидание датчика уровня
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277. \243\340\242M"), hour, minute, second);                               	//00:00:00 Рект. ЖДЁМ
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR(" \251po\263e\275\304 = %3i/%3i"), U_UROVEN, UROVEN_ALARM);                                  		// Уровень =
			break;
		case 100: //Окончание
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Pe\272\277\270\344-\345\270\307"), hour, minute, second);                            //00:00:00 Ректиф-ция
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
      sprintf_P(lcd_buffer, PSTR("\272o\275e\345 pe\272\277\270\344\270\272a\345\270\270")); 			                                    //конец ректификации
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,1);  
      sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), tEndRect);                           						// T* куба = 
			break;
		case 101: //Температура в ТСА превысила предельную
			formTSAErr();
			break;
		case 102: //Давление
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340a\263\273e\275\270e"), hour, minute, second);                          			//00:00:00 Давление
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("MPX5010 =%3i/%3i"), U_MPX5010, AlarmMPX5010);                                             
			break;

		}
	}
	else
	{
	PRINT_TEMPERATURES()
		if (StateMachine != 5)
		{
			if (IspReg != 118)  {
				// Phisik on 2018-07-06 I switched off the 3d screen and place power on the 2nd 
        sprintf_P(lcd_buffer, PSTR(" B\303x.\277o\272 = %3uA"), (uint16_t)MaxIOut);                     									// Вых.ток =
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0,3);
        sprintf_P(lcd_buffer, PSTR(" Mo\346\275oc\277\304 = %4iW"), FactPower);                         									// Мощность =
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0,2);
        sprintf_P(lcd_buffer, PSTR(" Ha\276p\307\266e\275\270e = %3uV"), (uint16_t)MaxVoltsOut);        									// Напряжение =
				// sprintf_P(lcd_buffer, PSTR("%3immV=%4u,%4u"), U_MPX5010, U_UROVEN, U_GLV);
			} else
				if (TekFraction < CountFractionRect)
				{
					if (TempFractionRect[TekFraction] > 0)
						sprintf_P(lcd_buffer, PSTR("%3imm t=%3i F%1i/%1i"), U_MPX5010, TempFractionRect[TekFraction], (int)TekFraction + 1, (int)CountFractionRect);
					else
						sprintf_P(lcd_buffer, PSTR("%3imm %4im F%1i/%1i"), U_MPX5010, (int)SecOstatok, (int)TekFraction + 1, (int)CountFractionRect);
				}
				else
					sprintf_P(lcd_buffer, PSTR("%3immV=%4u F%1i/%1i"), U_MPX5010, U_UROVEN, (int)TekFraction + 1, (int)CountFractionRect);
		}
		else sprintf_P(lcd_buffer, PSTR("%3imm reSt=%5i"), U_MPX5010, time1);
	}

}

void DisplayDistDefl()
{
	if (DispPage == 0)
	{
		switch (StateMachine)
		{
		case 0: //Не запущено
		case 1: //Нагрев до температуры 50 градусов
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT C \340E\252\247"), hour, minute, second);  //00:00:00 ДИСТ С ДЕФЛ
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			formTRZGDistill();
			break;
		case 2: //Ожидание закипания (прогреется дефлегматор)
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245C.\340E\252.PA\244"), hour, minute, second);  //00:00:00 ДИС.ДЕФ.РАЗ
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);                   //Уст.Мощность =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD 
      lcd.setCursor(0,1);
			sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344\273-pa=%3i/%3i"), DS_TEMP(TEMP_DEFL), TempDeflBegDistil);  //Темп.Дефл-ра=   
			break;
		case 3: //Ожидание закипания (прогреется куб дефлегматор)
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245C.\340E\252.PA\244"), hour, minute, second);           //00:00:00 ДИС.ДЕФ.РАЗ   
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
			sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);                    //Уст.Мощность =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,1);
      sprintf_P(lcd_buffer, PSTR("Te\274\276.K\171\262a =%3i/%3i"), DS_TEMP(TEMP_KUB), TempDeflBegDistil); //Темп.Куба =
			break;
		case 4: //Работа без дефлегматора
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT\245\247\247\261\341\245\261"), hour, minute, second);  //00:00:00 ДИСТИЛЛЯЦИЯ
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
			sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);        //Уст.Мощность =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
      sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344\273-pa=%3i/%3i"), DS_TEMP(TEMP_DEFL), TempDefl); //Темп.Дефл-ра=
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("\240E\244 \340E\252\247E\241MATOPA"));                                //БЕЗ ДЕФЛЕГМАТОРА
			break;
		case 5: //Работа с 50% дефлегмацией
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT\245\247-\341\245\261"), hour, minute, second);  //00:00:00 ДИСТИЛ-ЦИЯ
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);                       //Уст.Мощность =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344\273-pa=%3i/%3i"), DS_TEMP(TEMP_DEFL), TempDefl - DeltaDefl);  //Темп.Дефл-ра=
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("C \340E\252\247E\241MA\341\245E\246 50%%"));                                  //С ДЕФЛЕГМАЦИЕЙ 50%
			break;
		case 6: //Работа с 100% дефлегмацией
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT\245\247-\341\245\261"), hour, minute, second);     //00:00:00 ДИСТИЛ-ЦИЯ
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);           //Уст.Мощность =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344\273-pa=%3i/%3i"), DS_TEMP(TEMP_DEFL), TempDefl - DeltaDefl);  //Темп.Дефл-ра=
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("C \340E\252\247E\241MA\341\245E\246 100%%"));                                 //С ДЕФЛЕГМАЦИЕЙ 100%
			break;
		case 7: //Ожидание для охлаждения
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT.C \340E\252\247"), hour, minute, second);		    //00:00:00 ДИСТ.С ДЕФЛ
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
			sprintf_P(lcd_buffer, PSTR("T.K\171\262a=%3i \243\343\265\274%4i"), DS_TEMP(TEMP_KUB), SecondsEnd);  //Т.Куба=   Ждём
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,1);
      sprintf_P(lcd_buffer, PSTR("O\243\245\340AH\245E OX\247A\243\340EH\245\261"));                       //ОЖИДАНИЕ ОХЛАЖДЕНИЯ
			break;
		case 100: //Окончание
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u OKOH\253AH\245E"), hour, minute, second);       //00:00:00 ОКОНЧАНИЕ
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
			sprintf_P(lcd_buffer, PSTR("Te\274\276.K\171\262a=%3i KOHE\341"), DS_TEMP(TEMP_KUB));      //Темп.Куба=  КОНЕЦ
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,1);
      sprintf_P(lcd_buffer, PSTR("\340\245CT-\341\245\245 C \340E\252\247E\241M."), hour, minute, second);  //ДИСТ-ЦИЯ С ДЕФЛЕГМ.
			break;
		}
	}
	else
	{
		PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("Pa\267-\345a Mo\346\275oc\277\270=%4u-%4iW"), U_VODA, U_UROVEN, deltaPower); //Раз-ца Мощности=
    my_lcdprint(lcd_buffer); 
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \263 Tape = %4u"), U_UROVEN);            //Уровень в Таре =
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,2); 
    sprintf_P(lcd_buffer, PSTR("Po\267\273\270\263 Bo\343\303 =%4u"), U_VODA);             //Розлив Воды =
	}
}
/*
void DisplaySimpleGLV()
 {

 if (DispPage==0)
 {
 switch (StateMachine)
 {
 case 0: //Не запущено
 case 1: //Нагрев до температуры 50 градусов
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Not"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 formTRZGDistill();
 break;
 case 2: //Ожидание закипания (прогреется дефлегматор)
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Rzg"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 formTRZGDistill();
 break;
 case 3: //Ожидание закипания (прогреется куб дефлегматор)
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Rzg"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),DS_TEMP(TEMP_KUB),TempDeflBegDistil,Power);
 break;
 case 4: //Отбор голов
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sGl Otb"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),DS_TEMP(TEMP_KUB),Temp3P,PowerGlvDistil);
 break;
 case 5: //Ожидание 60 секунд для охлаждения
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sOtbGlv"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i Wait=%4i"),DS_TEMP(TEMP_KUB),SecondsEnd);
 break;
 case 100: //Окончание
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u sOtbGlv"),hour,minute,second);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i end"),DS_TEMP(TEMP_KUB));
 break;
 case 101: //Температура в ТСА превысила предельную
 formTSAErr();
 break;
 }
 }
 else
 {
 PRINT_TEMPERATURES();
 sprintf_P(lcd_buffer,PSTR("V=%4u,%4u,%4u"),U_VODA,U_UROVEN,U_GLV);
 }
 }*/

void DisplaySimpleDistill()
{
	if (DispPage == 0)
	{
		if (IspReg == 104)
		{
			V1 = 1;
			V2 = Temp1P;
		}
		if (IspReg == 106)
		{
			V1 = 2;
			V2 = Temp2P;
		}
		if (IspReg == 107 || IspReg == 105)
		{
			V1 = 3;
			V2 = Temp3P;
		}

		if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1 O\277\262op"), hour, minute, second, V1);  						//00:00:00 Отбор
		else  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\270c\277\270\273\273\307\345\270\307"), hour, minute, second);         		//00:00:00 Дистилляция

		switch (StateMachine)
		{
		case 0: //Не запущено
		case 1: //Нагрев до температуры 50 градусов
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			break;
		case 2: //Ожидание закипания (прогреется дефлегматор)
			if (IspReg != 105)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u %1u  Pa\267\264o\275"), hour, minute, second, V1); 				//00:00:00 1 Разгон
			else sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u  Pa\267\264o\275"), hour, minute, second, V1);   								//00:00:00  Разгон
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("\340\270c\277\270\273. pa\267\264o\275"));      															//Дистил. разгон
			formTRZGDistill();
			break;
		case 3: //Дистилляция
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw  = %4iW"), UstPower);   														// Заданая Pw =
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i/%3i"), DS_TEMP(TEMP_KUB), V2);  												// T* куба =
			break;
		case 4: //Ожидание 60 секунд для охлаждения
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR(" \243\343\270\277e = %4i"), SecondsEnd);    																// Ждите =
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR(" T* \272y\262a =%3i"), DS_TEMP(TEMP_KUB));  														// T* куба =
			break;
		case 100: //Окончание
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("               KOHE\341"));               															//           КОНЕЦ
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR(" T* \272y\262a = %3i"), DS_TEMP(TEMP_KUB));  																// T* куба =
			break;
		case 101: //Температура в ТСА превысила предельную
			formTSAErr();
			break;
		}
	}
	else
	{
		PRINT_TEMPERATURES();																										// D2 - вторая страница
		  sprintf_P(lcd_buffer, PSTR("     I =  %3uA"), (uint16_t)MaxIOut);     															//   I =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("      Pw = %4iW"), FactPower);              																//   Рw =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("    U =  %3uV"), (uint16_t)MaxVoltsOut);     																//   U =
	}
}

void DisplayFracionDistill()
{
	if (DispPage == 0)
	{
		sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\270c.\344p.%1i/%1i"), hour, minute, second, (int)(TekFraction < CountFractionDist) ? TekFraction + 1 : CountFractionDist, (int)CountFractionDist);
																																	//00:00:00 Дист.фр.
		switch (StateMachine)
		{
		case 0: //Не запущено
		case 1: //Нагрев до температуры 50 градусов
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			break;
		case 2: //Ожидание закипания (прогреется дефлегматор)
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u \340\245CT.\252P.PA\244"), hour, minute, second); //00:00:00 ДИСТ.ФР.РАЗ
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			formTRZGDistill();
			break;
		case 3: //Дистилляция
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			if (TekFraction < CountFractionDist) V2 = TempFractionDist[TekFraction];
			if (V2 >= 0){ sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);   //Уст.Мощность =   
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa K\171\262a=%3i/%3i)"), DS_TEMP(TEMP_KUB), V2);     //Темп-ра Куба=   
			}
			else { sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);      //Уст.Мощность =
      my_lcdprint(lcd_buffer);  
			sprintf_P(lcd_buffer, PSTR("Oc\277a\273oc\304: %5imin"), (int)SecOstatok);          //Осталось:
			}
			break;
		case 4: //Ожидание 60 секунд для охлаждения
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("\243\343\270\277e: %4i"), time3);        //Ждите:
      my_lcdprint(lcd_buffer); 
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa K\171\262a=%3i"), DS_TEMP(TEMP_KUB));  //Темп-ра Куба=
			break;
		case 100: //Окончание
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("               KOHE\341"));          //КОНЕЦ
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa K\171\262a=%3i"), DS_TEMP(TEMP_KUB));  // Темп-ра Куба=
			break;
		case 101: //Температура в ТСА превысила предельную
			formTSAErr();
			break;
		}
	}
	else
	{
		PRINT_TEMPERATURES();  
		sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4uW"), UstPower);  //Уст.Мощность =
    my_lcdprint(lcd_buffer); 
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \263 Tape =%4u"), U_UROVEN);   //Уровень в Таре =
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,2); 
    sprintf_P(lcd_buffer, PSTR("Po\267\273\270\263 Bo\343\303 =%4u"), U_VODA);    //Розлив Воды =
	}
}

void DisplayRazvar()
{
	if (DispPage == 0)
	{
		if (IspReg == 114)  sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u OX\247.\244ATOPA"), hour, minute, second);  //00:00:00 ОХЛ.ЗАТОРА
		else sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u PA3BAP \244EPH"), hour, minute, second);  //00:00:00 РАЗВАР ЗЕРН
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		switch (StateMachine)
		{
		case 0: //Не запущено
		  //            case 1: //Нагрев до температуры 50 градусов
		  //              sprintf_P(lcd_buffer,PSTR("t=%3i P=%4i"),DS_TEMP(TEMP_RAZVAR),UstPower); 
		  //              break;
		case 1: //Нагрев до температуры 50 градусов
			sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);    //Уст.Мощность =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa \263o\343\303=%3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempZSP * 10);   //Темп-ра воды=
			break;
		case 2: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
			sprintf_P(lcd_buffer, PSTR("\244AC\256\250\304 \244EPHA > KH.\332"), DS_TEMP(TEMP_RAZVAR));    //ЗАСЫПЬ ЗЕРНА > КН.(стрелка вверх)
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa BO\340\256 = %3i"), DS_TEMP(TEMP_RAZVAR));   //Темп-ра ВОДЫ =
			break;
		case 3: //Нагрев до температуры 64 градуса
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);   //Уст.Мощность =
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR("Te\274\276.\244ATOPA =%3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempZSPSld * 10);   //Темп.ЗАТОРА =
			break;
		case 4: //Ожидание 15 минут, поддержка температуры
      sprintf_P(lcd_buffer, PSTR("Oc\277a\273oc\304: %4i"), time2);   //Осталось:
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);      
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa \244ATOPA = %3i"), DS_TEMP(TEMP_RAZVAR));  //Темп-ра ЗАТОРА =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
			sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);   //Уст.Мощность =
			break;
		case 5: //Нагрев до кипения
			if (ds1820_devices < 2){
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), UstPower);  //Уст.Мощность =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Te\274\276.\244ATOPA =%3i/%3i"), DS_TEMP(TEMP_RAZVAR), TempKipenZator);}  //Темп.ЗАТОРА =
			else {
        sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 = %4iW"), UstPower);   //Уст.Мощность =
        my_lcdprint(lcd_buffer);
				sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344\273-pa=%3i/%3i"), DS_TEMP(TEMP_DEFL), TempKipenZator);}  //Темп.Дефл-ра=
			break;
		case 6: //Варка
      sprintf_P(lcd_buffer, PSTR("Oc\277a\273oc\304: %4i"), time2);  //Осталось:
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);      
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa \244ATOPA = %3i"), DS_TEMP(TEMP_RAZVAR));  //Темп-ра ЗАТОРА =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("\251c\277.Mo\346\275oc\277\304 =%4iW"), PowerRazvZerno);  //Уст.Мощность =
			break;
		case 7: //Охлаждение до температыры осахаривания
      sprintf_P(lcd_buffer, PSTR("TEM\250-P\256 OCAXAP\245BAH\245\261"));   //ТЕМП-РЫ ОСАХАРИВАНИЯ
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("OX\247A\243\340EH\245E \340O"));    //ОХЛАЖДЕНИЕ ДО
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
			sprintf_P(lcd_buffer, PSTR("Te\274\276.\244ATOPA =%3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempZSPSld * 10);  //Темп.ЗАТОРА =
			break;
		case 8: //Поддержание температуры 50 градусов, пока не произойдет ручной переход к следующему этапу.
      sprintf_P(lcd_buffer, PSTR("\245 HA\243M\245 KH. \332"));  //И НАЖМИ КН.(стрелка вверх)
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
			sprintf_P(lcd_buffer, PSTR("\244AC\256\250\304 CO\247O\340"));  //ЗАСЫПЬ СОЛОД
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa BO\340\256 = %3i"), DS_TEMP(TEMP_RAZVAR));  //Темп-ра ВОДЫ =
			break;
		case 9: //Мешаем 10 минут
			sprintf_P(lcd_buffer, PSTR("PA\240OTA ME\254A\247K\245 = %4i"), time2); //РАБОТА МЕШАЛКИ =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i"), DS_TEMP(TEMP_RAZVAR));  //ТЕМП.ЗАТОРА =
			break;
		case 10: //Осахаривание      
      sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i"), DS_TEMP(TEMP_RAZVAR)); //ТЕМП.ЗАТОРА =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("OCAX-E OCTA\247OC\304=%4i"), time2); //ОСАХ-Е ОСТАЛОСЬ=
			break;
		case 11: //Охлаждение до температуры первичного внесения дрожжей осахаривания
			sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i/400"), DS_TEMP(TEMP_RAZVAR)); //ТЕМП.ЗАТОРА =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("OX\247.\340O BHEC-\261 \340PO\243\243."));   //ОХЛ.ДО ВНЕС-Я ДРОЖЖ.
			break;
		case 12: //Охлаждение до температыры осахаривания
      sprintf_P(lcd_buffer, PSTR("TEM\250-P\256 OCAXAP\245BAH\245\261"));  //ТЕМП-РЫ ОСАХАРИВАНИЯ
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("OX\247A\243\340EH\245E \340O"));  //ОХЛАЖДЕНИЕ ДО
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
			sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempHLDZatorBrog1 * 10);  //ТЕМП.ЗАТОРА =
			break;
		case 13: //Поддержка брожения, ничего не делаем, только мешаем периодически
      sprintf_P(lcd_buffer, PSTR("\245\340\242T \240PO\243EH\245E \356"));    //ИДЁТ БРОЖЕНИЕ (знак многогранника)
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempHLDZatorBrog1 * 10);  //ТЕМП.ЗАТОРА =
			break;
		case 14: //Поддержка брожения - охлаждение
      sprintf_P(lcd_buffer, PSTR("- OX\247A\243\340EH\245E \356"));   //- ОХЛАЖДЕНИЕ (знак многогранника)
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("\250O\340\340EP\243KA \240PO\243EH\245\261")); //ПОДДЕРЖКА БРОЖЕНИЯ
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
			sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i/%3i"), DS_TEMP(TEMP_RAZVAR), (int)TempHLDZatorBrog1 * 10 - 5);  //ТЕМП.ЗАТОРА =
			break;
		case 100: //Окончание
      sprintf_P(lcd_buffer, PSTR("KOHE\341"));
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR("TEM\250.\244ATOPA = %3i KOHE\341"), DS_TEMP(TEMP_RAZVAR));  //ТЕМП.ЗАТОРА =    КОНЕЦ
			break;
		}
	}
	else
	{
		PRINT_TEMPERATURES();		
    sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 H\250\241 =%4u"), U_NPG);  //Уровень НПГ =
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("                    "));
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,2);
    sprintf_P(lcd_buffer, PSTR("Te\274\276.\267ac.co\273o\343a =%3u"), (int)TempZSPSld * 10);  //Темп.зас.солода =
	}
}
/*
void DisplayNDRF()
 {
 if (DispPage==0)
 {
 switch (StateMachine)
 {
 case 0: //Не запущено
 case 1: //Не запущено
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NDRF"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i P=%4i"),DS_TEMP(TEMP_KUB),Power);
 break;
 case 2: //Разгон
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND RZG"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 if (tEndRectRazgon>0) sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),DS_TEMP(TEMP_KUB),tEndRectRazgon,UstPower);
 else sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %4iW"),DS_TEMP(TEMP_RK20),-tEndRectRazgon,UstPower);
 break;
 case 3: //Стабилицация колонны
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND NSB"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("t=%3i(%4i)%4iW"),DS_TEMP(TEMP_RK20),(int)(SecOstatok),PowerRect);
 break;
 case 4: //Отбор голов
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND GLV"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 if (UrovenProvodimostSR==0)
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i %4iW"),DS_TEMP(TEMP_KUB),tEndRectOtbGlv,PowerRect);
 else
 if (UrovenProvodimostSR>0)
 sprintf_P(lcd_buffer,PSTR("Pr=%3i/%3i %4iW"),U_GLV,UrovenProvodimostSR,PowerRect);
 else
 sprintf_P(lcd_buffer,PSTR("Tm=%3i/%3i %4iW"),(int) SecOstatok,-UrovenProvodimostSR,PowerRect);
 break;
 case 5: //Стоп, ожидание возврата температуры
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Stop"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i %2i%%"),DS_TEMP(TEMP_RK20),tStabSR,ProcChimSR);
 break;
 case 6: //Ректификация
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u NDst %2i%%"),hour,minute,second,ProcChimSR);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tN=%3i/%3i/d%2i"),DS_TEMP(TEMP_RK20),tStabSR+tDeltaRect,tDeltaRect);
 break;
 case 7: //Отбор хвостов
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Hvst"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),DS_TEMP(TEMP_KUB),tEndRect);
 break;
 case 8: //Отбор ожидание 3 минут
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND Wait"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),DS_TEMP(TEMP_KUB),tEndRect);
 break;
 case 9: //Ожидание датчика уровня
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u R Wait"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("by Urov=%3i/%3i"),U_UROVEN,UROVEN_ALARM);
 break;
 case 100: //Окончание
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u ND End"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("tK=%3i/%3i"),DS_TEMP(TEMP_KUB),tEndRect);
 break;
 case 101: //Температура в ТСА превысила предельную
 formTSAErr();
 break;
 case 102: //Давление
 sprintf_P(lcd_buffer,PSTR("%02u:%02u:%02u Pres"),hour,minute,second);
 //sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);
 my_lcdprint(lcd_buffer); //вывод сz`одержимого буфера на LCD
 sprintf_P(lcd_buffer,PSTR("MPX5010=%3i/%3i"),U_MPX5010,AlarmMPX5010);
 break;

 }
 }
 else
 {
 PRINT_TEMPERATURES();
 sprintf_P(lcd_buffer,PSTR("%3immV=%4u,%4u"),U_MPX5010,U_UROVEN,U_GLV);
 }

 }*/

void DisplayNBK()
{
	if (DispPage == 0)
	{
		switch (StateMachine)
		{
		case 0: //Не запущено
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u H\240K"), hour, minute, second);  //00:00:00 НБК
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("\340a\263\273e\275\270e =%3imm"), U_MPX5010);  //Давление =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("Te\274\276-pa K\171\262a =%3i"), DS_TEMP(TEMP_KUB)); //Темп-ра Куба =
			break;
		case 1: //Ожидание закипания (прогреется дефлегматор)
		case 2: //Ожидание закипания (прогреется дефлегматор)
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u H\240K PA\244\241OH"), hour, minute, second);  //00:00:00 НБК РАЗГОН
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			formTRZGDistill();
			break;
		case 3: //Ожидание запуска
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u CTAPT H\240K"), hour, minute, second); //00:00:00 СТАРТ НБК
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("KH.\331 > CTAPT, %3imm"), U_MPX5010); //КН.(стрелка вверх)> СТАРТ,
			break;
		case 4: //Запущено
		case 6: //Запущено, подача браги остановлена
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u PA\240OTA H\240K"), hour, minute, second);  //00:00:00 РАБОТА НБК
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR("\340a\263\273e\275\270e =%3imm"), U_MPX5010);  //Давление =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      sprintf_P(lcd_buffer, PSTR("C\272opoc\277\304 Hacoca=%4i"), (int)SpeedNBK); //Скорость Насоса=
			break;
		case 5: //Превышение температуры вверху
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u H\240K"), hour, minute, second);  //НБК
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2); 
      sprintf_P(lcd_buffer, PSTR("\250PEB\256\254EH\245E TEM\250.BEPX"));   //ПРЕВЫШЕНИЕ ТЕМП.ВЕРХ
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,1);
			sprintf_P(lcd_buffer, PSTR("Te\274\276.\340e\344=%3i/970,s%4i"), DS_TEMP(TEMP_DEFL), time2);  //Темп.Деф=
			break;
		case 100: //Окончание
			sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u H\240K-KOHE\341"), hour, minute, second);  //НБК-КОНЕЦ
			//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,2);
			sprintf_P(lcd_buffer, PSTR("\340a\263\273e\275\270e =%3imm"), U_MPX5010);  //Давление =
      my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
      lcd.setCursor(0,1);
      sprintf_P(lcd_buffer, PSTR("C\272opoc\277\304 Hacoca=%4i"), (int)SpeedNBK);  //Скорость Насоса=
			break;
		}
	}
	else
	{
		PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("\274a\272c.\267a \276ep\270o\343=%3imm"), MaxPressByPeriod);  //макс.за период=
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("Mo\346\275oc\277\304 =%4uW"), UstPower);   //Мощность =
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,2);
    sprintf_P(lcd_buffer, PSTR("\340a\263\273e\275\270e =%3imm,"), U_MPX5010);  //Давление =
	}
}
void DisplayTestKLP()
{
	if (DispPage == 0)
	{
		sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u Tec\277 \272\273a\276."), hour, minute, second);   										//00:00:00 Тест клап.
		//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("Coc\277-e \276po\345ecca = %3i"), StateMachine);  														//Сост-е процесса =
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("Te\272-\271 %% \254\245M CP = %3i"), ProcChimSR);  															//Тек-й % ШИМ СР =
	}
	else
	{
		PRINT_TEMPERATURES();
		sprintf_P(lcd_buffer, PSTR("ds3 =%3u, ds4 =%3u"), DS_TEMP(3), DS_TEMP(4));  
    my_lcdprint(lcd_buffer); 
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("                    "));  
    my_lcdprint(lcd_buffer); 
    sprintf_P(lcd_buffer, PSTR(" \251po\263e\275\304 \241A\244A = %4u"), U_GAS);  															// Уровень ГАЗА =
	}
}

void DisplayExtContol()
{
	if (DispPage == 0)
	{
		sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u BHE\254.\251\250PAB\247"), hour, minute, second);  //ВНЕШ.УПРАВЛ
		//sprintf_P(lcd_buffer,PSTR("%u%u%u%u  %u%u%u%u"),PINB.4,PINB.3,PINB.2,PINA.7, PINA.6,PINA.5,PINA.4,PINA.3);                     
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("T=%3u,%3u P=%4iW"), DS_TEMP(TEMP_KUB), DS_TEMP(TEMP_DEFL), UstPower);
	}
	else
	{
		PRINT_TEMPERATURES();
		sprintf_P(lcd_buffer, PSTR("%3u,%3u \241A\244 = %4u"), DS_TEMP(3), DS_TEMP(4), U_GAS); 												//..... ГАЗ=
	}

}

void DisplayBeer()
{
	if (DispPage == 0)
	{
		sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u BAP\245M C\251C\247O"), hour, minute, second);  //00:00:00 ВАРИМ СУСЛО
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		if (StateMachine == 2) { sprintf_P(lcd_buffer, PSTR("                    ")); 
                             my_lcdprint(lcd_buffer);
		                         sprintf_P(lcd_buffer, PSTR("T=%3i/%3i \250A\251\244A%2i/%2i"), DS_TEMP(TEMP_TERMOSTAT), (int)tempP[KlTek] * 10, (int)KlTek, (int)CntPause);
		                                                    //Т=    ПАУЗА 
		}                             
		if (StateMachine == 3)
		{
			if (timeP[KlTek] != 0){
				sprintf_P(lcd_buffer, PSTR("Oc\277a\273oc\304:%5i"), time2);  //Осталось:
        my_lcdprint(lcd_buffer);
        sprintf_P(lcd_buffer, PSTR("\250a\171\267a -%2i(%2i)"), (int)KlTek, (int)CntPause);}  //Пауза -
        
			else
				sprintf_P(lcd_buffer, PSTR("HA\243M\245 KH.\331 %2i(%2i)"), (int)KlTek + 1, (int)CntPause);  //НАЖМИ КН.(стрелка вверх)

		}
		if (StateMachine == 100){  sprintf_P(lcd_buffer, PSTR("KOHE\341"));
                               my_lcdprint(lcd_buffer);
                               sprintf_P(lcd_buffer, PSTR("                    "));}
	}
	else
	{
		PRINT_TEMPERATURES();
    sprintf_P(lcd_buffer, PSTR("Mo\346\275oc\277\304 =%4iW"), UstPower);   // Мощность = 	
    my_lcdprint(lcd_buffer);
    lcd.setCursor(0,3);
    sprintf_P(lcd_buffer, PSTR("                    "));  
    my_lcdprint(lcd_buffer);   
    sprintf_P(lcd_buffer, PSTR("Hacoc - %5i"), time1);        
	}
}

void DisplayData()
{
	int tic1;
	static int PrevState = 0;
	static char flDspDop = 0; // Флаг для отображения информации (через раз)
	char j; // Временная переменная для цикла
	flNumStrPrint = 0;
	flDspDop = !flDspDop;

	hour = Seconds / 3600;
	tic1 = Seconds % 3600;
	minute = tic1 / 60;
	second = tic1 % 60;

	if (FlState == 0)
		lcd.setCursor(0, 0);
	else
	{
		// Если предыдущее состояние было 0, то даем задерку в 1/10 секунды, чтобы не слишком часто обновлялся
		// дисплей.
		if (PrevState == 0)  delay(100);

		if (FlState != PrevState)
		{
			lcd.clear();  //очистка дисплея   
			PrevState = FlState;
		}

		lcd.setCursor(0, 0);
	}

#ifdef TESTMEM
	DEBUG_SERIAL.println(F("\n[memCheck_displ]"));
	DEBUG_SERIAL.println(freeRam());
#endif

	switch (FlState)
	{
	case 0:

		if (DispPage < 2) // Первые две страницы отображаются по-разному, остальные всегда одни и те же
		{
			switch (IspReg)
			{
			case 101: // Displaying
			  //sprintf_P(lcd_buffer,PSTR("S=%5u TT=%5u"),Seconds,MaxTimeTimer); 

			  //  Выводим сетевое напряжение по тому же принципу, что и работают дешевые вольтметры, то есть максимальное количество вольт в сети умножаем на 0,707
			  //  это напряжение нужно для калибровки нашего измерителя

				if (DispPage == 0)
				{
					sprintf_P(lcd_buffer, PSTR("     %02u:%02u:%02u"), hour, minute, second);  												//   00:00:00 
					my_lcdprint(lcd_buffer);
          lcd.setCursor(0,2);
					sprintf_P(lcd_buffer, PSTR("                   ")); 
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,3);
          sprintf_P(lcd_buffer, PSTR("                    "));
          my_lcdprint(lcd_buffer);
          sprintf_P(lcd_buffer, PSTR("  Zr=%4u  U=%3i"), TicZero, (uint16_t)MaxVoltsOut);
				}

				if (DispPage == 1)
				{
					PRINT_TEMPERATURES();         
          sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \277apa =%4u"), U_UROVEN);  														//Уровень тара =
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,3);
          sprintf_P(lcd_buffer, PSTR("Po\267\273\270\263 \263o\343\303 =%4u"), U_VODA); 													//Розлив воды =
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,2);
          sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \264o\273o\263 =%4u"), U_GLV);  													//Уровень голов =
				}
       
				break;
			case 102: // Термостат         
				if (DispPage == 0)
				{
					sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u TEPMOCTAT:"), hour, minute, second, Delta);
					my_lcdprint(lcd_buffer);
          lcd.setCursor(0,2); 
					sprintf_P(lcd_buffer, PSTR("\340e\273\304\277a =%2i, Coc\277.=%1i"), Delta, StateMachine);  //Дельта =  , Сост.
          my_lcdprint(lcd_buffer); 
          lcd.setCursor(0,1); 
          sprintf_P(lcd_buffer, PSTR("Te\274\276. =%3i/%3i"), DS_TEMP(TEMP_TERMOSTAT));  // Темп. =
				}
				else
				{
					PRINT_TEMPERATURES();
          sprintf_P(lcd_buffer, PSTR("\340a\263\273e\275\270e =%3imm"), U_MPX5010);   //Давление =      
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,3); 
					sprintf_P(lcd_buffer, PSTR("                    "));
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,2);
          sprintf_P(lcd_buffer, PSTR("ds3=%3u, ds4=%3u"), DS_TEMP(3), DS_TEMP(4));         
				}
				break;
			case 115: // Таймер
				if (DispPage == 0)
				{
					sprintf_P(lcd_buffer, PSTR(" %02u:%02u:%02u Ta\271\274ep"), hour, minute, second, Delta);									// 00:00:00 Таймер
					my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
					minute = Seconds / 60;
          lcd.setCursor(0,2); 
          sprintf_P(lcd_buffer, PSTR(" \244a\343a\275\275a\307 Pw = %4iW"), UstPower);															// Заданная Р* = 
          my_lcdprint(lcd_buffer);
          lcd.setCursor(0,1); 
          sprintf_P(lcd_buffer, PSTR("	Ta\246\274ep(m) = %3i/%3i"), minute, timerMinute);														//	Таймер(м) =
				}
				else
				{
					PRINT_TEMPERATURES();
					sprintf_P(lcd_buffer, PSTR(" \251c\277. Pw = 4iW"), PowerMinute);  															// Уст. Pw =
          my_lcdprint(lcd_buffer);
          sprintf_P(lcd_buffer, PSTR("ds3=%3u, ds4=%3u"), DS_TEMP(3), DS_TEMP(4));
				}
				break;
			case 116: // Пивоварня - клон браумастера
				DisplayBeer();
				break;
			case 103: // Регулятор мощности
				if (DispPage == 0)
				{
#ifndef USE_SLAVE
          sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u RMU=%3u"), hour, minute, second, (uint16_t)MaxVoltsOut);
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
#if SIMPLED_VERSION==20
          sprintf_P(lcd_buffer, PSTR("P=%3u/%3u%% c%3u"), UstPowerReg / 10, Power / 10, indexOut);
#else
          sprintf_P(lcd_buffer, PSTR("P=%4u/%4u c%3u"), FactPower, UstPowerReg, indexOut);
#endif
#ifdef TEST
          if (NUM_PHASE > 1) sprintf_P(lcd_buffer, PSTR("%s"), my_rx_buffer);
#endif
#else
          sprintf_P(lcd_buffer, PSTR("%02u:%02u:%02u RMU=%3u"), hour, minute, second, (uint16_t)MaxVoltsOut);
          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
          sprintf_P(lcd_buffer, PSTR("PSlv=%4u/%4u"), UstPower, Power);
#endif
        }
        else
        {
          PRINT_TEMPERATURES();
#ifndef USE_SLAVE
          sprintf_P(lcd_buffer, PSTR("Up to auto=%4uW"), Power);
#else
          if (flAutoDetectPowerTEN)
            sprintf_P(lcd_buffer, PSTR("Up to auto=%4uW"), Power);
          else
            sprintf_P(lcd_buffer, PSTR("SlaveOn (Up)=%1i"), (int)SlaveON);
#endif
        }
        break;
			case 105: // Отбор голов33
			  //          DisplaySimpleGLV();
			  //          break;
			case 104: // Перевый (недробный) отбор
			case 106: // Второй дробный отбор
			case 107: // Третий дробный отбор
				DisplaySimpleDistill();
				break;

			case 117: // Фракционная перегонка
				DisplayFracionDistill();
				break;

			case 108: // Разваривание
			case 113: // Разваривание мучно-солодового затора (без варки).
			case 114: // Разваривание
				DisplayRazvar();
				break;
			case 109: // Ректификация
			case 118: // Ректификация
				DisplayRectif();
				break;
#ifndef TEST
#ifndef DEBUG // Это отображение информации выкусываем, если в режиме теста, потому что не хватает памяти
#ifndef TESTGSM
#ifndef TESTGSM1
			case 110: // Дистилляция с дефлегматором
				DisplayDistDefl();
				break;
			case 111: // НДРФ
				DisplayRectif();
				break;
#endif
#endif
#endif
#endif

			case 112: // NBK
				DisplayNBK();
				break;

			case 130: // Внешнее управление
				DisplayExtContol();
				break;
			case 129: // тест клапанов
				DisplayTestKLP();
				break;
			case 248:
				//          sprintf_P(lcd_buffer,PSTR("LOW LEVEL VOLTS!")); 
				//          my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				//          sprintf_P(lcd_buffer,PSTR("Umax=%i Sec=%3i"),(uint16_t)MaxVoltsOut,(int) ErrCountIndex*12); 
				break;
			case 249:
				sprintf_P(lcd_buffer, PSTR("He\277 \343e\277e\272\277opa \275y\273\307!"));  												//Нет детектора нуля!
				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				sprintf_P(lcd_buffer, PSTR("Umax=%i"), (uint16_t)MaxVoltsOut);
				break;
			case 250:
				sprintf_P(lcd_buffer, PSTR("Po\267\273\270\263 \263o\343\303!"));  															//Розлив воды!
				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				break;
			case 251:
				sprintf_P(lcd_buffer, PSTR("O\301\270\262\272a ds18b20!"));  																//Ошибка ds18b20!
				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				sprintf_P(lcd_buffer, PSTR("HOMEP ds - %i"), (int)NumErrDs18);

				break;
			case 252:
				sprintf_P(lcd_buffer, PSTR(" !!! \343a\277\345\270\272 \264a\267a !!!"));  													// !!! Дачик газа !!!
				my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
				break;
			case 253:
				sprintf_P(lcd_buffer, PSTR("OC\251\254EH\245E H\250\241!"));  //ОСУШЕНИЕ НПГ!
				my_lcdprint(lcd_buffer);
        lcd.setCursor(0,3); 
				sprintf_P(lcd_buffer, PSTR("Ko\273-\263o CPA\240AT-\246 =%i"), countAlrmNPG); //КОЛ-ВО СРАБАТ-Й =
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0,2);
        sprintf_P(lcd_buffer, PSTR("\251POBEH\304 H\250\241 =%i"), U_NPG);  //УРОВЕНЬ НПГ =
				break;
			case 254:
				sprintf_P(lcd_buffer, PSTR("H\250\241 \250EPE\250O\247HEH!"));   //НПГ ПЕРЕПОЛНЕН!
				my_lcdprint(lcd_buffer); 
        lcd.setCursor(0,3);
				sprintf_P(lcd_buffer, PSTR("KO\247-BO CPA\240AT-\246 =%i"), countAlrmNPG);  //КОЛ-ВО СРАБАТ-Й =
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0,2);
        sprintf_P(lcd_buffer, PSTR("\251POBEH\304 H\250\241 =%i"), U_NPG); //УРОВЕНЬ НПГ =
				break;
			}
			// Это обычное состояние
			//
			if (StateNPG == 1 && DispPage == 0) sprintf_P(lcd_buffer, PSTR("HA\250O\247HEH\245E H\250\241...")); //НАПОЛНЕНИЕ НПГ...

		}
		// Третья страница отображения универсальна, там показываем напряжение, дистанцию и возможное число ошибок
		// расчета среднеквадратичного. 

		if (DispPage == 2)
		{
#if USE_GSM_WIFI==1
			sprintf_P(lcd_buffer, PSTR("C3 %3i,w%3u,i%3i"), (int)flGPRSState, (int)timeWaitGPRS, (int)timeGPRS);
			my_lcdprint(lcd_buffer);
#else
			sprintf_P(lcd_buffer, PSTR("C3     He\277 GSM"));   																			//C3   Hет GSM 
			my_lcdprint(lcd_buffer);
#endif
      sprintf_P(lcd_buffer, PSTR("  B\303x. I =  %3uA"), (uint16_t)MaxIOut); 																//Вых. I =     
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("  B\303x. P = %4iW"), FactPower);   																		//Вых. P =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("  B\303x. U =  %3uV"), (uint16_t)MaxVoltsOut);     														//Вых. U =			
		}
		// На четвертой странице показываем всю температуру и давление
		if (DispPage == 3)
		{
			sprintf_P(lcd_buffer, PSTR("C4    T* :"));  																					//С4    Tc* :
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);     
      sprintf_P(lcd_buffer, PSTR(" ds4-%3i, Pmm -%3imm"), DS_TEMP(4), U_MPX5010);  															//	ds4-   Pmm -   
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR(" TCA-%3i, ds3 -%3i,"), DS_TEMP(TEMP_TSA) ,DS_TEMP(3));   													// TSA-, ds3-             
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR(" Ky\262-%3i, 20c\274-%3i,"), DS_TEMP(TEMP_KUB), DS_TEMP(TEMP_DEFL));  									// Куб-, 20см-   		                       
		}

		// На пятой странице показываем часы, температуру 2 датчиков, U,I,P (переделал под себя)
		if (DispPage == 4)
		{
		sprintf_P(lcd_buffer, PSTR(     "%02u:%02u:%02u"), hour, minute, second);  																		
      my_lcdprint(lcd_buffer);
		lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR(" U = %3uV, I = %3uA"), (uint16_t)MaxVoltsOut, (uint16_t)MaxIOut);  
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("    P = %4iW"), FactPower);  													         
      my_lcdprint(lcd_buffer);
	  lcd.setCursor(0,1);
      sprintf_P(lcd_buffer, PSTR("Ky\262= %3i, Bo\343a= %3i"),DS_TEMP(TEMP_KUB),DS_TEMP(TEMP_TSA)); 													          
      my_lcdprint(lcd_buffer);
	  	}

		// На шестой странице показываем состояние датчиков уровней
		if (DispPage == 5)
		{
			sprintf_P(lcd_buffer, PSTR("C6 \251po\263e\275\304 \264a\267a=%4u"), U_GAS);   													//С6 Уровень газа=
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3); 
      sprintf_P(lcd_buffer, PSTR("  Pw = %4uW"), UstPwrPH1);  																				//  Pw =
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);   
      sprintf_P(lcd_buffer, PSTR(" \275y\273\307/ce\272.(zPS)= %3u"), (int)zPSOut);  														// нуля/сек.(zPS) =
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("\253\270c\273o \276pep\303\263a\275\270\271"));  															//Число прерываний                       			
		}

		// На седьмой странице показываем состояние регулятора мощности
		if (DispPage == 6)
		{
#if NUM_PHASE==1
			sprintf_P(lcd_buffer, PSTR(" %4i,%4i,%4iW"), UstPwrPH1, UstPwrPH2, UstPwrPH3);
			my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR("C7 %3i,%3i,%3i %%"), KtPhase[0], KtPhase[1], KtPhase[2]);
#else
			sprintf_P(lcd_buffer, PSTR("C7    Z=%4u"), TicZero);																			//C7    Z=
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("Bz=%3u"), (int)b_value[0]);    																			//Bz=
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);   
			sprintf_P(lcd_buffer, PSTR("Bpe\274\307 o\277\272p.\272\273\276.=%4u"), TimeOpenKLP);  											//Время откр.клп.=
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Bpe\274\307 o\277\272p.с\270\274.=%4u"), TimeOpenTriac);   												//Время откр.сим.=  
#endif
		}

		// На восьмой можно сменить состояние процесса.
		if (DispPage == 7)
		{
			sprintf_P(lcd_buffer, PSTR("C8  \250po\345ecc :"));  																			//С8   Процесс :
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("                    "));
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("                    "));
      my_lcdprint(lcd_buffer);
			sprintf_P(lcd_buffer, PSTR("Coc\277o\307\275\270e = %i"), (int)StateMachine);  													//Состояние =   
		}

		// На девятой состояние ПИД-регулятора
		if (DispPage == 8)
		{
			sprintf_P(lcd_buffer, PSTR("C9   O\301\270\262\272\270 :")); 																	//С9  Ошибки :
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("Dt =%4i  It =%4i"), Dt, It);																				// Dt =  It = 
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("C\277ap\256e - %4i"), OldErrOut);  																		//Старые -
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("Ho\263\303e - %4i"), NewErr); 			    															//Новые - 
		}
		// На Десятой странице показываем максимальные температуры за процесс температуру и давление
		if (DispPage == 9)
		{
		  sprintf_P(lcd_buffer, PSTR("C10 Ma\272c.\277e\274\276epa\277ypa"));  																//С10 Макс.температура
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("ds3=%3i, ds4=%3i"),MAX_DS_TEMP(3),MAX_DS_TEMP(4));
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("ds1=%3i, ds2=%3i,"),MAX_DS_TEMP(1),MAX_DS_TEMP(2));
      my_lcdprint(lcd_buffer);
      sprintf_P(lcd_buffer, PSTR("\267a \276po\345ecc: ds0=%3i,"),MAX_DS_TEMP(0));  														//за процесс: ds0=
		}
		// На 11  странице показываем параметры расчета ПИД-регулятора
		if (DispPage == 10)
		{
			sprintf_P(lcd_buffer, PSTR("C11 O\301\270\262\272\270 \277e\274\276-p\303:"));  												//C11 Ошибки темп-ры:
			my_lcdprint(lcd_buffer);
      lcd.setCursor(0,3);
      sprintf_P(lcd_buffer, PSTR("KId %4i %4i %3i"), KtT, ItTemp, DtTemp);																	//KId
      my_lcdprint(lcd_buffer);
      lcd.setCursor(0,2);
      sprintf_P(lcd_buffer, PSTR("C\277ap\303e - %3i"), OldErrTempOut); 																	//Старые -
      my_lcdprint(lcd_buffer);     
      sprintf_P(lcd_buffer, PSTR("Ho\263\303e - %3i"), NewErrTemp);  																		//Новые -
		}

		if (flDspDop && DispDopInfo > 0) // Если отображаем дополнительную информацию, тогда проверяем ее статус
		{

			if (BeepStateProcess > 1)
			{
				if (DispDopInfo == 3 || DispDopInfo == 4)
				{
					if (!(BeepStateProcess&B00000010) && DispDopInfo == 3) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 2 разряде
					if (!(BeepStateProcess&B00000100) && DispDopInfo == 4) my_beep(BEEP_LONG); // Не пищим, если установлена маска в 3 разряде
				}
				else
					my_beep(BEEP_LONG); // Сначала пищим, предупреждая.
			}
			else
				my_beep(BEEP_LONG); // Сначала пищим, предупреждая.


			if (DispDopInfo == 1) sprintf_P(lcd_buffer, PSTR("CMEH\245 TAP\251!(%3i)"), (IspReg == 117 || IspReg == 118) ? COUNT_ALARM_UROVEN_FR - CountAlarmUroven : COUNT_ALARM_UROVEN - CountAlarmUroven); //Выводим на экран инфомацию о необходимости замены тары.
			if (DispDopInfo == 2) sprintf_P(lcd_buffer, PSTR("\250POTE\253KA BO\340\256!(%3i)"), COUNT_ALARM_VODA - CountAlarmVoda); //Выводим на экран инфомацию о необходимости замены тары.
			if (DispDopInfo == 3) sprintf_P(lcd_buffer, PSTR("H\245\244KOE U! %3iV"), (uint16_t)MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
			if (DispDopInfo == 6) sprintf_P(lcd_buffer, PSTR("B\256COKOE U! %3iV"), (uint16_t)MaxVoltsOut); //Выводим на экран инфомацию о необходимости замены тары.
			if (DispDopInfo == 4) sprintf_P(lcd_buffer, PSTR("O\254\245\240KA ds! ds =%2i"), (int)NumErrDs18); //Выводим на экран инфомацию о ошибке чтения датчика.
			if (DispDopInfo == 5) sprintf_P(lcd_buffer, PSTR("\340AB\247EH\245E(!)=%3i/%3i"), U_MPX5010, AlarmMPX5010); //Выводим на экран инфомацию о ошибке чтения датчика.

#if USE_GSM_WIFI==1
	  // Активизируем разовую отправку состояния на сервер                                                   //СМЕНИ ТАРУ! (%3i)
			if (FlToGSM > 1 && flGPRSState != 20 && flGPRSState != 164 && (timeGPRS == 0 || flNeedCall == 1))    //ПРОТЕЧКА ВОДЫ! (%3i)
			{                                                                                                    //НИЗКОЕ U! %3iV
				if (flNeedCall == 1)                                                                               //ВЫСОКОЕ U! %3iV
				{                                                                                                  //ОШИБКА ds! ds =%2i
					flGPRSState = 40; // Активируем звонок если в этом есть необходимость                            //ДАВЛЕНИЕ(!)= %3i/%3i
				}
				else
				{   // Если в данный момент не производится дозвон, тогда активируем GPRS сессию. 
					if (flNeedCall != 2) flGPRSState = 2;
				}
				// Активируем длительную сессию GPRS
				flNeedRefrServer = 0;
				timeGPRS = 250;
			}
#endif
		}

		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 100:
		sprintf_P(lcd_buffer, PSTR("                "), FlState);	//Settings Menu  										
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" Me\275\306 \275ac\277po\271\272\270"));                                                                 // Меню настройки
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 101:
		sprintf_P(lcd_buffer, PSTR("                "));			//Monitoring Mode  										
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" Pe\266\270\274 \276poc\274o\277pa"));																	// Режим просмотра		
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 102:
		sprintf_P(lcd_buffer, PSTR("                "));
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" Tep\274oc\277a\277"));																					// Термостат	
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 103:
		sprintf_P(lcd_buffer, PSTR("                ")); 														
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" Pe\264y\273\307\277op \274o\346\275oc\277\270"));														// Регулятор мощности
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 104:
		sprintf_P(lcd_buffer, PSTR("                 ")); 							
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \340\270c\277\270\273\273\307\345\270\307")); 															// Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("   \262e\267 \344pa\272\345\270\271")); 																//   без фракций
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 105:
		sprintf_P(lcd_buffer, PSTR("                 ")); 							
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \340\270c\277\270\273\273\307\345\270\307"));  														// Дистилляция	
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("   o\277\262op \264o\273o\263"));																		//   oтбор голов
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 106:
		sprintf_P(lcd_buffer, PSTR("                 ")); 							
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \340\270c\277\270\273\273\307\345\270\307"));  														// Дистилляция 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("   o\277\262op \277e\273a"));             																//   отбор тела
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 107:
		sprintf_P(lcd_buffer, PSTR("                 ")); 							
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \340\270c\277\270\273\273\307\345\270\307"));  														// Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("   o\277\262op x\263oc\277o\263"));               														//   отбор хвостов
        my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 108:
		sprintf_P(lcd_buffer, PSTR("                 "));        
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \244a\277op \267ep\275a"));        																	// Затор зерна
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 109:
		sprintf_P(lcd_buffer, PSTR("                 "));    
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" Pe\272\277\270\344\270\272a\345\270\307"));	                          								// Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 110:// Дистилляция с дефлегматором
		sprintf_P(lcd_buffer, PSTR("IsR = \340\245CT\245\247\247\261\341\245\261")); // = ДИСТИЛЛЯЦИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("C \340E\252\247E\241MATOPOM"));  //С ДЕФЛЕГМАТОРОМ
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 111:// НДРФ
		sprintf_P(lcd_buffer, PSTR("IsR = H\340P\252    "));  //НДРФ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("                    "));
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 112:// НБК
		sprintf_P(lcd_buffer, PSTR("IsR = H\240K        "));  //НБК
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("                    "));
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 113:// солодо-мучной затор (без варки
		sprintf_P(lcd_buffer, PSTR("IsR=\244ATOP CO\247O\340-M\251KA"));  //ЗАТОР СОЛОД-МУКА
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("(\240E\244 BAPK\245)"), PowerRect);   //БЕЗ ВАРКИ
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 114:// Охлаждение затора
		sprintf_P(lcd_buffer, PSTR("IsR = OX\247A\243\340EH\245E"));  //ОХЛАЖДЕНИЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244ATOPA C \253\245\247\247EPOM"), PowerRect);  //ЗАТОРА С ЧИЛЛЕРОМ
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 115:// Таймер
		sprintf_P(lcd_buffer, PSTR("                    "));    
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" Ta\271\274ep +"));  																					// Таймер +
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR(" pe\264y\273\307\277op \274o\346\275oc\277\270"));  													// регулятор мощности
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 116:// Варка пива
		sprintf_P(lcd_buffer, PSTR("IsR = \250\245BOBAPEH\245E")); //ПИВОВАРЕНИЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("                    "));
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 117:// Фракционная дистилляция
		sprintf_P(lcd_buffer, PSTR(" \340\270c\277\270\273\273\307\345\270\307"));  														// Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  c \344pa\272\345\270o\275\275\270\272o\274"));  														//  с фракционником
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 118:// Фракционная ректификация
		sprintf_P(lcd_buffer, PSTR(" Pe\272\277\270\344\270\272a\345\270\307"));  															// Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  c \344pa\272\345\270o\275\275\270\272o\274"));  														//  с фракционником
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 130:
		sprintf_P(lcd_buffer, PSTR("IsR = BHE\254HEE"));  //ВНЕШНЕЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\251\250PAB\247EH\245E"));  //УПРАВЛЕНИЕ
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 129:
		sprintf_P(lcd_buffer, PSTR("                    ")); 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" Tec\277 \272\273a\276a\275o\263"));																	// Тест клапанов
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 200:
		sprintf_P(lcd_buffer, PSTR("T* \277ep\274oc\277a\277a = %5i"), TempTerm); 															//Т* термостата=
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 201:
		sprintf_P(lcd_buffer, PSTR("T\257H - Pw \275o\274\270\275a\273\304\275a\307")); 													//ТЭН - Рw номинальная
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" \274o\346\275oc\277\304 = %5u"), Power);  																//  мощность =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 202:
		sprintf_P(lcd_buffer, PSTR("   T\257H - Pw \277e\272y\346a\307"));    																//ТЭН - Pw текущая
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  \274o\346\275oc\277\304 = %5u"), UstPowerReg);  														//  мощность =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 203:
		sprintf_P(lcd_buffer, PSTR("\250APAMETP USART =%u"), FlToUSART);  //ПАРАМЕТР USART =
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 204:
		sprintf_P(lcd_buffer, PSTR("\250APAMETP GSM=%u"), FlToGSM);  //ПАРАМЕТР GSM=
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		if (FlToGSM == 1 || FlToGSM == 0) sprintf_P(lcd_buffer, PSTR("GSM (SMS)"));
		if (FlToGSM == 2) sprintf_P(lcd_buffer, PSTR("GPRS Megafon"));
		if (FlToGSM == 3) sprintf_P(lcd_buffer, PSTR("GPRS BeeLine"));
		if (FlToGSM == 4) sprintf_P(lcd_buffer, PSTR("GPRS MTS"));
		if (FlToGSM == 5) sprintf_P(lcd_buffer, PSTR("GPRS Rostelecom"));
		if (FlToGSM == 6) sprintf_P(lcd_buffer, PSTR("GPRS Tele 2"));
		if (FlToGSM >= 7) sprintf_P(lcd_buffer, PSTR("GPRS Reserv %i"), (int)FlToGSM);
		if (FlToGSM == 10) sprintf_P(lcd_buffer, PSTR("Wi-Fi"));
		if (FlToGSM == 11) sprintf_P(lcd_buffer, PSTR("Android ext"));
		if (FlToGSM == 12) sprintf_P(lcd_buffer, PSTR("Android int"));
		if (FlToGSM > 12) sprintf_P(lcd_buffer, PSTR("Err! 0..11 (%i)"), (int)FlToGSM);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 205:
		sprintf_P(lcd_buffer, PSTR("  Tep\274oc\277a\277 :"));																					//   Термостат :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  \343e\273\304\277a = %3i"), Delta);  																		//   дельта =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer);
		break;
	case 206:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));  															// Дистилляция 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \262e\267 \344pa\272\345\270\271 :"));  																	//  без фракций :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR(" T* o\272o\275\300a\275\270\307 = %3i"), Temp1P);  															//Т* окончания =
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 207:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));  															// Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \277e\273a :"));  																						//   тела :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" T* o\272o\275\300a\275\270\307 = %3i"), Temp2P);  															//Т* окончания =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 208:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));  															// Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("    x\263oc\277o\263 :"));  																				//   хвостов :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" T* o\272o\275\300a\275\270\307 = %3i"), Temp3P);  															//Т* окончания =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 209:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 																//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  pa\267\264o\275 \272o\273o\275\275\303 :"));  															//  разгон колонны :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" +/- T* \272o\275e\345 = %3i"), tEndRectRazgon);  															// +/-Т* конец =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 210:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" pa\262o\300a\307 \274o\346\275oc\277\304 :"));  															// рабочая мощность :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    Pw = %3iW"), PowerRect);  																				//   Pw =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 211:
		sprintf_P(lcd_buffer, PSTR(" Kope\272\345\270\307 \343a\277\300\270\272o\263"));  														// Корекция датчиков
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("     ds18b20"));                                
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 212:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("    o\277\262op \264o\273o\263 :"));  																		//    отбор голов :
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" T* o\272o\275\300a\275\270\307 = %3i"), tEndRectOtbGlv); 													// Т* окончания =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 213:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \254\245M o\277\262opa \264o\273o\263"));  																// ШИМ отбора голов 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    \276ep\270o\343 = %5u"), timeChimRectOtbGlv);                                                           //   период =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 214:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 																//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \254\245M o\277\262opa \264o\273o\263"));  																// ШИМ отбора голов 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    \276po\345e\275\277\303 = %3i"), (int)ProcChimOtbGlv);  												//   проценты =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 215:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \254\245M o\277\262opa c\276\270p\277a"));  																// ШИМ отбора спирта
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    \276ep\270o\343 = % 5u"), timeChimRectOtbSR);  															//   период =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 216:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   o\277\262op c\276\270p\277a:")); 																		//   отбор спирта:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  T* \343e\273\304\277a = %3u"), tDeltaRect);  																//    Т* дельта =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 217:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("    o\277\262op c\276\270p\277a:"));  																		// отбор спирта:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  T* \272o\275e\345 = %3i"), tEndRectOtbSR);  																//  Т* конец =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 218:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \272o\275e\345 o\277\262opa:"));  																			// конец отбора:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  T* \272o\275e\345 = %3i"), tEndRect);                                                                     //  Т* конец =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 250:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 																//   Ректификация
		my_lcdprint(lcd_buffer); 
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" \274\270\275. % o\277\262opa"));  																			// мин. % отбора
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR(" c\276\270p\277a = %2i"), minProcChimOtbSR);  																// спирта =
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 251:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307"));  															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \277e\274\276epa\277ypa"));  																			// температура
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" c\277a\262\270\273\270\267a\345\270\270 = %3i"), tStabSR);  												//стабилизации =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 252:
		sprintf_P(lcd_buffer, PSTR("    Pe\272\277\270\344\270\272a\345\270\307")); 															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \275a\300a\273o o\277\262opa"));  																		//начало отбора
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("   c\276\270p\277a: \254\245M% = %2i"), begProcChimOtbSR); 													//спирта: ШИМ% =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 253:
		sprintf_P(lcd_buffer, PSTR(" \250o\276pa\263\272a MPX = %4i"), P_MPX5010); 																//Поправка MPX =
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  %4i/%4i"), U_MPX5010, U_MPX5010 + P_MPX5010);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 219:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));    														//  Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" o\277\262op \264o\273o\263")); 																		// отбор голов
		my_lcdprint(lcd_buffer);
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("  \274o\346\275oc\277\304 = %4iW"), PowerGlvDistil);													// мощность =
		my_lcdprint(lcd_buffer);
		break;
	case 220:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));    														//  Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR(" o\277\262op \277e\273a")); 																			// отбор тела
		my_lcdprint(lcd_buffer);
		lcd.setCursor(0, 2);
		sprintf_P(lcd_buffer, PSTR("  \274o\346\275oc\277\304 = %4iW"), PowerDistil);  														// мощность =
		my_lcdprint(lcd_buffer);  //вывод содержимого буфера на LCD
		break;
	case 221:
		sprintf_P(lcd_buffer, PSTR(" T* \275a\300a\273a \343\270c\277\270\273.")); 															//  Т* начала дистил.
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("   c \343e\344o\274 = %3i"), TempDeflBegDistil); 														//   с дефом =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 222:
		sprintf_P(lcd_buffer, PSTR("TEM\250.BO\340\256 HA B\256XO\340E"));  //ТЕМП.ВОДЫ НА ВЫХОДЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("\340\245CT\245\247\247\261\341\245\245 =%3i"), TempDefl); //ДИСТИЛЛЯЦИИ
    my_lcdprint(lcd_buffer); 
		lcd.setCursor(0, 1);
    sprintf_P(lcd_buffer, PSTR("\340E\252\247E\241MATOPA \250P\245"));    //ДЕФЛЕГМАТОРА ПРИ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 223:
		sprintf_P(lcd_buffer, PSTR("\340E\247\304TA TEM\250EPAT\251P\256"));  //ДЕЛЬТА ТЕМПЕРАТУРЫ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\340\245CT\245\247\247\261\341\245\245 =%3i"), DeltaDefl); //ДИСТИЛЛЯЦИИ =
    my_lcdprint(lcd_buffer); 
		lcd.setCursor(0, 1);
    sprintf_P(lcd_buffer, PSTR("\340E\252\247E\241MATOPA \250P\245")); //ДЕФЛЕГМАТОРА ПРИ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 224:
		sprintf_P(lcd_buffer, PSTR("TEM\250EPAT\251PA B K\251\240E")); //ТЕМПЕРАТУРА В КУБЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("C \340E\252\247E\241MATOPOM =%3i"), tEndDistDefl);	//С ДЕФЛЕГМАТОРОМ =
    my_lcdprint(lcd_buffer);
		lcd.setCursor(0, 1);
    sprintf_P(lcd_buffer, PSTR("OKOH\253AH\245\261 \340\245CT-\341\245\245"));  //ОКОНЧАНИЯ ДИСТ-ЦИИ
    my_lcdprint(lcd_buffer);
		break;
	case 225:
		sprintf_P(lcd_buffer, PSTR(" C\270\264\275a\273 o\272o\275\300a\275\270\307"));  													// Сигнал окончания
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("   \276po\345ecca = %1u"), BeepEndProcess); 																//   процесса =
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 226:
		sprintf_P(lcd_buffer, PSTR(" C\270\264\275a\273 coc\277o\307\275\270\307")); 														// Сигнал состояния 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("   \276po\345ecca = %1u"), BeepStateProcess); 																//   процесса =
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); 
		break;
	case 227:
		sprintf_P(lcd_buffer, PSTR(" \244\263y\272 \275a\266a\277\270\307"));   															// Звук нажатия
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("   \272\275o\276o\272 = %1u"), BeepKeyPress); 																//   кнопок =
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 228:
		sprintf_P(lcd_buffer, PSTR("MO\342HOCT\304 \250P\245 PA\244BAPE")); //МОЩНОСТЬ ПРИ РАЗВАРЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244EPHA =%4iW"), PowerRazvZerno);  //ЗЕРНА
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 229:
		sprintf_P(lcd_buffer, PSTR("MO\342HOCT\304 \250P\245 BAPKE"));  //МОЩНОСТЬ ПРИ ВАРКЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244EPHA =%4iW"), PowerVarkaZerno);  //ЗЕРНА =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 230:
		sprintf_P(lcd_buffer, PSTR("\250EP\245O\340 O\240HOB\247EH\245\261")); //ПЕРИОД ОБНОВЛЕНИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("CEPBEPA(ce\272) =%3u"), (unsigned int)PeriodRefrServer); //СEPBEPA(ceк) =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer);
		break;
	case 231:
		sprintf_P(lcd_buffer, PSTR(" U \276epe\264pe\263a")); 																				// U перегрева
		my_lcdprint(lcd_buffer);
		sprintf_P(lcd_buffer, PSTR("   \272\273a\276a\275a = %3uV"), (unsigned int)NaprPeregrev); 											//   клапана =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer);
		break;
	case 232:
		sprintf_P(lcd_buffer, PSTR("\251POBEH\304 \240AP\340\256 =%4i"), UrovenBarda); //УРОВЕНЬ БАРДЫ =
		my_lcdprint(lcd_buffer);
		sprintf_P(lcd_buffer, PSTR("\240AP\340OOTBO\340\253\245K(%4u)"), U_GLV);  //БАРДООТВОДЧИКА
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer);
		break;
	case 233:
		sprintf_P(lcd_buffer, PSTR("\251po\263e\275\304 \276po\263o\343\270\274oc\277\270")); 												// Уровень проводимости
		my_lcdprint(lcd_buffer);
    sprintf_P(lcd_buffer, PSTR("   c\276\270p\277a = %4i"), UrovenProvodimostSR); 															//   спирта =
    lcd.setCursor(0, 1);
    my_lcdprint(lcd_buffer);
		break;
	case 234:
		sprintf_P(lcd_buffer, PSTR("C\277a\262\270\273\270\267a\345\270\307 \272o\273o\275\275\303")); 										//Стабилизация колонны
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("(+/-)\263pe\274\307 c\277.= %5icek"), TimeStabKolonna); 												//(+/-)время ст. =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 235:
		sprintf_P(lcd_buffer, PSTR(" \250pa\263\272a T* \270 \254\245M"));  																// Правка Т* и ШИМ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("   pac\300e\277 \254\245M = %3i"), (int)CntCHIM);				 										//   расчет ШИМ =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 236:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \275ac\277po\271\272a \254\245M:")); 																	//  настройка ШИМ:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" a\263\277o - %% \254\245M = %3i"), (int)DecrementCHIM); 												// авто - % ШИМ =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer);
		break;
	case 237:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \275ac\277po\271\272a \254\245M:")); 																	//  настройка ШИМ:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" a\263\277o + %% \254\245M = %3i"), (int)IncrementCHIM); 												// авто + % ШИМ =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer);
		break;
	case 238:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307")); 															//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \276ep\270o\343 \254\245M +"));  																		//  период ШИМ +
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("   %% \254\245M = %5icek"), TimeAutoIncCHIM);  															//    % ШИМ =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 239:
		sprintf_P(lcd_buffer, PSTR(" Bpe\274\307 pec\277a\262.\272o\273o\275\275\303"));  													// Время рестаб.колонны
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  (+/-) \343e\273\304\277a = %5icek"), TimeRestabKolonna); 												//  (+/-) дельта =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 240:
		sprintf_P(lcd_buffer, PSTR("\250A\251\244\256 \244AT\245PAH\245\261:")); //ПАУЗЫ ЗАТИРАНИЯ:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("KO\247\245\253ECTBO - %3i"), (int)CntPause); //КОЛИЧЕСТВО -
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 241:
		sprintf_P(lcd_buffer, PSTR("   Koppe\272\345\270\307 Pw :")); 																		// Коррекция Рw:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    ASC712 = %3i"), (int)CorrectASC712);																//   ASC712 =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 242:
		sprintf_P(lcd_buffer, PSTR("IP A\340PEC CEPBEPA:")); //IP AДPEC CEPBEPA:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%3u.%3u.%3u.%3u"), (unsigned int)ip[0], (unsigned int)ip[1], (unsigned int)ip[2], (unsigned int)ip[3]);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 243:
		sprintf_P(lcd_buffer, PSTR("\250OPT CEPBEPA:")); //ПОРТ СЕРВЕРА:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%u"), ipPort);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 244:
		sprintf_P(lcd_buffer, PSTR("ID O\240OP\251\340OBAH\245\261:")); //ID ОБОРУДОВАНИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%s"), idDevice);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 245:
		sprintf_P(lcd_buffer, PSTR("HOMEP TE\247E\252OHA:")); //НОМЕР ТЕЛЕФОНА:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%s"), my_phone);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 246:
		sprintf_P(lcd_buffer, PSTR(" Tpe\263o\264a - \343a\263\273e\275\270e:"));  														// Тревога - давление:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("   MPX5010 = %i"), AlarmMPX5010);																	//   MPX5010 =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 247:
		sprintf_P(lcd_buffer, PSTR("\250P\245MEHEH\245E ABTOHOM."));   //ПРИМЕНЕНИЕ АВТОНОМ.
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("OX\247A\243\340EH\245\261 =%i"), FlAvtonom); //ОХЛАЖДЕНИЯ =
    lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 248:
		sprintf_P(lcd_buffer, PSTR("BPEM\261 OTKP. K\247A\250AHA"));  //ВРЕМЯ ОТКР.КЛАПАНА
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\240AP\340OOTBO\340\253\245KA =%i"), (int)timeOpenBRD); //БАРДООТВОДЧИКА =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 249:
		sprintf_P(lcd_buffer, PSTR("   PID \276apa\274e\277p\303:")); 																	//PID параметры:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" %4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 254:
		sprintf_P(lcd_buffer, PSTR("MO\342HOCT\304 H\240K = %4iW"), PowerNBK); //МОЩНОСТЬ НБК =
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 255:
		sprintf_P(lcd_buffer, PSTR("Wi-Fi To\300\272a \343oc\277\171\276a:")); //Wi-Fi Точка доступа:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%s"), WiFiAP);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 256:
		sprintf_P(lcd_buffer, PSTR("Wi-Fi \250apo\273\304 ce\277\270:"));  //Wi-Fi Пароль сети:
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%s"), WiFiPass);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 257:
		sprintf_P(lcd_buffer, PSTR("  \340\270c\277\270\273\273\307\345\270\307"));    														//  Дистилляция
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \272o\273\270\300ec\277\263o"));  																	//   количество
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    \344pa\272\345\270\271 = %3i"), (int)CountFractionDist); 											//    фракций =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 258:
		sprintf_P(lcd_buffer, PSTR("   Pe\272\277\270\344\270\272a\345\270\307:")); 														//   Ректификация
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("   \272o\273\270\300ec\277\263o"));  																	//   количество
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("    \344pa\272\345\270\271 = %3i"), (int)CountFractionRect);  											//    фракций =
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 259:
		sprintf_P(lcd_buffer, PSTR("TEM\250EPAT\251PA \244AC\256\250\245")); //ТЕМПЕРАТУРА ЗАСЫПИ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244ATOPA =%3i"), (int)TempZSP * 10);  //ЗАТОРА =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 260:
		sprintf_P(lcd_buffer, PSTR("TEM\250-PA OCAXAP\245BAH\245\261")); //ТЕМП-РА ОСАХАРИВАНИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244ATOPA =%3i"), (int)TempZSPSld * 10);  //ЗАТОРА
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 261:
		sprintf_P(lcd_buffer, PSTR("TEM\250-PA \240PO\243EH\245\261"));  //ТЕМП-РА БРОЖЕНИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\244ATOPA =%3i"), (int)TempHLDZatorBrog1 * 10);  //ЗАТОРА
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 262:
		sprintf_P(lcd_buffer, PSTR("PhasePW %5i="), Power);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%4i+%4i+%4i"), PowerPhase[0], PowerPhase[1], PowerPhase[2]);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 263:
		sprintf_P(lcd_buffer, PSTR("\252A\244A %% %3i="), (int)KtPhase[0] + KtPhase[1] + KtPhase[2]);  //ФАЗА %
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("%3i + %3i + %3i"), (int)KtPhase[0], (int)KtPhase[1], (int)KtPhase[2]);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 264:
		sprintf_P(lcd_buffer, PSTR("M\245H\245MA\247\304HOE \340AB\247EH\245E"));  //МИНИМАЛЬНОЕ ДАВЛЕНИЕ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD                 //НБК:
		sprintf_P(lcd_buffer, PSTR("H\240K: %3i +%3i = %3i"), (int)minPressNBK * 5, (int)deltaPressNBK, (int)minPressNBK * 5 + (int)deltaPressNBK);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 265:
		sprintf_P(lcd_buffer, PSTR("\340E\247\304TA \340AB\247EH\245\261"));  //ДЕЛЬТА ДАВЛЕНИЯ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD            //НБК:
		sprintf_P(lcd_buffer, PSTR("H\240K: %3i +%3i = %3i"), (int)minPressNBK * 5, (int)deltaPressNBK, (int)minPressNBK * 5 + (int)deltaPressNBK);
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 266:
		sprintf_P(lcd_buffer, PSTR("\250EP\245O\340 KOPPEK\341\245\245")); //ПЕРИОД КОРРЕКЦИИ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
    sprintf_P(lcd_buffer, PSTR("\240PA\241\245(H\240K) = %3i"), (int)timePressNBK * 5); //БРАГИ(НБК) =
    my_lcdprint(lcd_buffer);    
    lcd.setCursor(0,1);
    sprintf_P(lcd_buffer, PSTR("CKOPOCT\245 \250O\340A\253\245")); //СКРОСТИ ПОДАЧИ
    my_lcdprint(lcd_buffer);
		break;
	case 267:
		sprintf_P(lcd_buffer, PSTR("\251\250PAB\247EH\245E HACOCOM")); //УПРАВЛЕНИЕ НАСОСОМ
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("H\240K - %3i"), (int)UprNasosNBK);  //НБК -
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 268:
		sprintf_P(lcd_buffer, PSTR("OT\240OP(%%) \341AP\241A"));  //ОТБОР % ЦАРГА
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("\250ACTEP-\341\245\245(+/-) =%3i"), (int)ProcChimOtbCP);  //ПАСТЕР-ЦИИ(+/-) =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
#if ENABLE_SENSOR_SORTING
	case 269:
		sprintf_P(lcd_buffer,PSTR("DS18B20 \250p\270c\263o\270\277\304 ")); 															// DS18B20 Присвоить  
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		sprintf_P(lcd_buffer, PSTR("  \275o\263\303\271 \275o\274ep")); 																//   новый номер
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			// Печатаем номера всех наших сенсоров
		for(int i = 0, n = 0; i < MAX_DS1820; i++) {
			n += sprintf_P(lcd_buffer + n, (i>0)?PSTR(" %02d"):PSTR("%02d"), (int)ds1820_nums[i] + 1);
		}
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;  
#endif
	case 300:
		sprintf_P(lcd_buffer, PSTR(" Te\274\276epa\277ypa DS%1i = %3u"), nPopr, DS_TEMP(nPopr)); 										//Температура DS%1i = 
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR(" \276O\276p. = %3i T* = %3u"), ds1820_popr[nPopr], (DS_TEMP(nPopr) + ds1820_popr[nPopr])); 			// попр. =   Т* =
		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 301:
		sprintf_P(lcd_buffer, PSTR("TempK(%1i)=%4i"), (int)nPopr, tempK[nPopr]);
		if (flPopr == 0)
		{
			sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
		}

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		sprintf_P(lcd_buffer, PSTR("  \254\245M (%1i) = %3i"), (int)nPopr, (int)CHIM[nPopr]);  //ШИМ(%1i)=%3i
		if (flPopr == 1)
		{
			sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
		}

		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 302:
		// Первое значение это время работы насоса
		if (nPopr == 0)
			sprintf_P(lcd_buffer, PSTR("PA\240OTA HACOCA =%2im"), (int)tempP[nPopr]);  //РАБОТА НАСОСА =
		else
			sprintf_P(lcd_buffer, PSTR("TEM\250.\250A\251\244\256\356%1i=%3i.0"), (int)nPopr, (int)tempP[nPopr]); //ТЕМП.ПАУЗЫ(значок шестигранника)=

		if (flPopr == 0)
		{
			sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
		}

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		if (nPopr == 0)
			sprintf_P(lcd_buffer, PSTR("\250A\251\244A HACOCA = %2im"), (int)timeP[nPopr]); //ПАУЗА НАСОСА =
		else
			sprintf_P(lcd_buffer, PSTR("BPEM\261 \250A\251\244\256\356%1i=%3im"), (int)nPopr, (int)timeP[nPopr]); //ВРЕМЯ ПАУЗЫ(значок шестигранника)=

		if (flPopr == 1)
		{
			sprintf_P(lcd_buffer, PSTR("%s %c"), lcd_buffer, '*');
		}

		lcd.setCursor(0, 1);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 303:
		sprintf_P(lcd_buffer, PSTR("%3u.%3u.%3u.%3u"), (unsigned int)ip[0], (unsigned int)ip[1], (unsigned int)ip[2], (unsigned int)ip[3]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j = -1;
		while (j < nPopr * 4)
		{
			j++;
			lcd_buffer[j] = ' ';
		}
		lcd_buffer[j + 1] = '*';
		lcd_buffer[j + 2] = 0;

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		break;
	case 304:
		sprintf_P(lcd_buffer, PSTR("%s (%3u)"), idDevice, (unsigned int)idDevice[nPopr]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j = 0;
		while (j < nPopr)
		{
			lcd_buffer[j] = ' ';
			j++;
		}
		lcd_buffer[j] = '*';
		lcd_buffer[j + 1] = 0;

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		break;

	case 305:
		sprintf_P(lcd_buffer, PSTR("%s/%3u)"), my_phone, (unsigned int)my_phone[nPopr]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j = 0;
		while (j < nPopr)
		{
			lcd_buffer[j] = ' ';
			j++;
		}
		lcd_buffer[j] = '*';
		lcd_buffer[j + 1] = 0;

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		break;
	case 309:
		sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PIDTemp[0], (int)PIDTemp[1], (int)PIDTemp[2]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		if (nPopr == 0) sprintf_P(lcd_buffer, PSTR("   P"));
		if (nPopr == 1) sprintf_P(lcd_buffer, PSTR("        I"));
		if (nPopr == 2) sprintf_P(lcd_buffer, PSTR("             D"));
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;

	case 310:
		sprintf_P(lcd_buffer, PSTR("%s /%3u"), WiFiAP, (unsigned int)WiFiAP[nPopr]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j = 0;
		while (j < nPopr)
		{
			lcd_buffer[j] = ' ';
			j++;
		}
		lcd_buffer[j] = '*';
		lcd_buffer[j + 1] = 0;

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		break;
	case 311:
		sprintf_P(lcd_buffer, PSTR("%s /%3u"), WiFiPass, (unsigned int)WiFiPass[nPopr]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j = 0;
		while (j < nPopr)
		{
			lcd_buffer[j] = ' ';
			j++;
		}
		lcd_buffer[j] = '*';
		lcd_buffer[j + 1] = 0;

		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

		break;
	case 312:
		// последнее значение это тест фракционника
		if (nPopr == MAX_CNT_FRACTION_DIST)
		{
			sprintf_P(lcd_buffer, PSTR(" Tec\277 \344pa\272\345\270o\275\272a"));  															// Тест фракционника
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR(" \343\270c\277\270\273\273\307\345\270\307 = %3i"), (int)TekFraction + 1);  						// дистилляция =
		}
		else
		{
			if (TempFractionDist[nPopr] >= 0){
        sprintf_P(lcd_buffer, PSTR("Te\274\276-pa \252pa\272\345\270o\275\275o\271")); //Темп-ра фракционной
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0, 1);
        sprintf_P(lcd_buffer, PSTR("\340\270c\277\270\273-\345\270\270(%1i)=%4i"), (int)nPopr + 1, (int)TempFractionDist[nPopr]); //Дистил-ции(%1i)=%4i
		}else{
        sprintf_P(lcd_buffer, PSTR("Bpe\274\307 \252pa\272\345\270o\275\275o\271")); //Втемя фракционнй
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0, 1);
        sprintf_P(lcd_buffer, PSTR("\340\270c\277\270\273-\270\270(%1i)=%5im"), (int)nPopr + 1, (int)-TempFractionDist[nPopr]); //Дистил-ии(%1i)=%5im
		    }
			if (flPopr == 0)
			{
				sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
			}

			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD

			if (flPopr == 1)  sprintf_P(lcd_buffer, PSTR("\251\264o\273=%3i*,%4iW"), (int)AngleFractionDist[nPopr], PowerFractionDist[nPopr]); //угол=
			else  sprintf_P(lcd_buffer, PSTR("\251\264o\273=%3i ,%4iW"), (int)AngleFractionDist[nPopr], PowerFractionDist[nPopr]);  //угол

			if (flPopr == 2)  sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
		}
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 313:
		// последнее значение это тест фракционника
		if (nPopr == MAX_CNT_FRACTION_RECT)
		{
			sprintf_P(lcd_buffer, PSTR(" Tec\277 \344pa\272\345\270o\275\272a")); 															// Тест фракционника
			my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
			sprintf_P(lcd_buffer, PSTR(" pe\272\277\270\344\270\272a\345\270\307 = %3i"), (int)TekFraction + 1);  							// ректификация = 
		}
		else
		{
			if (TempFractionRect[nPopr] >= 0){
				sprintf_P(lcd_buffer, PSTR("Te\274\276-pa \252pa\272\345\270o\275\275o\271")); //Темп-ра фракционной
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0, 1);
        sprintf_P(lcd_buffer, PSTR("Pe\272\277\270\344\270\272-\270\270(%1i)=%4i"), (int)nPopr + 1, (int)TempFractionRect[nPopr]); //Ректифик-ии(%1i)=%4i
			}else{
				sprintf_P(lcd_buffer, PSTR("Bpe\274\307 \252pa\272\345\270o\275\275o\271")); //Время фракционной
        my_lcdprint(lcd_buffer);
        lcd.setCursor(0, 1);
        sprintf_P(lcd_buffer, PSTR("Pe\272\277\270\344-\270\270(%1i)=%5im"), (int)nPopr + 1, (int)-TempFractionRect[nPopr]); ////Ректифик-ии(%1i)=%5im
			}
			if (flPopr == 0)
			{
				sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
			}
     
			my_lcdprint(lcd_buffer); 
			sprintf_P(lcd_buffer, PSTR("\251\264o\273 \252pa\272\345-\272a = %3i"), (int)AngleFractionRect[nPopr]); //угол фракц-ка =
       
			if (flPopr == 1)  sprintf_P(lcd_buffer, PSTR("%s%c"), lcd_buffer, '*');
		}
		lcd.setCursor(0, 2);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 314:
		sprintf_P(lcd_buffer, PSTR("%4i %4i %4i"), (int)PowerPhase[0], (int)PowerPhase[1], (int)PowerPhase[2]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		if (nPopr == 0) sprintf_P(lcd_buffer, PSTR(" \252 1"));         //ф 1
		if (nPopr == 1) sprintf_P(lcd_buffer, PSTR("      \252 2"));
		if (nPopr == 2) sprintf_P(lcd_buffer, PSTR("           \252 3"));
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
	case 315:
		sprintf_P(lcd_buffer, PSTR("%3i %3i %3i=%3i"), (int)KtPhase[0], (int)KtPhase[1], (int)KtPhase[2], (int)KtPhase[0] + KtPhase[1] + KtPhase[2]);
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		if (nPopr == 0) sprintf_P(lcd_buffer, PSTR("\252 1"));  //ф 1
		if (nPopr == 1) sprintf_P(lcd_buffer, PSTR("    \252 2"));
		if (nPopr == 2) sprintf_P(lcd_buffer, PSTR("        \252 3"));
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
#if ENABLE_SENSOR_SORTING
	case 316:
		// Печатаем номера всех наших сенсоров
		for(int i = 0, n = 0; i < MAX_DS1820; i++) {
			n += sprintf_P(lcd_buffer + n, (i>0)?PSTR(" %02d"):PSTR("%02d"), (int)ds1820_nums[i] + 1);
		}
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		lcd.setCursor(0, 1);
		j=0;
		while (j<(nPopr)*3+1)
		{
			lcd_buffer[j]=' ';
			j++;
		}
		lcd_buffer[j]='*';
		lcd_buffer[j+1]=0;
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
		break;
#endif
	default:
		break;
		}

	//    
	//  lcd.setCursor(0, 0);
	//  my_lcdprint(Seconds);
	//  lcd.setCursor(5, 0);
	//  my_lcdprint(MaxVoltsOut);
	//  lcd.setCursor(9, 0);
	//  my_lcdprint((long)MaxVoltsOut*707/1000);
	//  lcd.setCursor(0, 1);
	//  my_lcdprint(index_input);
	//  lcd.setCursor(5, 1);
	//  my_lcdprint(TimeOpenTriac);
	//  NeedDisplaying=false;
	//  lcd.setCursor(10, 1);
	//  my_lcdprint(TicZero);
	// предупреждения теперь выводим на всех страницах.

	if (flNumStrPrint < 2)
	{
		lcd_buffer[0] = 0;
		my_lcdprint(lcd_buffer); //вывод содержимого буфера на LCD
	}
	NeedDisplaying = false;
}
 
